# Official Arduino Library for databot™ 2.0 by aRbotics, LLC

<img src="https://databot.us.com/wp-content/uploads/2022/02/2.0-science-1.png">

Get the companion android app here: https://play.google.com/store/apps/details?id=de.rwth_aachen.vizeey

Learn about databot at https://databot.us.com

databot™ is an innovative STEM education product based on the open source Arduino
platform. It is a small form factor, 42.5mm x 42.5mm x 20mm, that contains 16 built in sensors for
experimentation, plus ports for expansion. This library and the sketches within it have
been designed to work “out of the box” with databot™ so that busy teachers can be up
and running quickly with activities for students. databot™ 2.0 is based on the Arduino ESP32 so
these libraries and sketches should work for anyone with an an Arduino ESP32 Board and the
sensors specified here if you want to build your own and modify the sketches
accordingly. We recommend shopping with Arduino, Sparkfun, and Adafruit for your
ESP32, sensors, and components if you do this as we all benefit from the incredible open
source resources they have contributed to the Arduino community.

This initial release of the databot™ library includes the following features:

- Complete libraries and sample sketches required to experiment and conduct educational activities using
the Arduino IDE with databot™ or a compatible ESP32 board with the appropriate
sensors.

- A set of sketches built and tested with the Vizeey™ app, an open source IOS/Android app that enables the creation of easy-to-use experiments for classroom use.  Vizeey™ is based on Phyphox, an open source software initiative from RWTH Aachen University.


This library is released to the public under the GPL3 license and can be adapted as
desired for any other purposes, including commercial use. Read the license for details.
A great deal of time, resources, and risk have been involved by all the parties involved
in developing databot™. We ask that you buy databot™ products and recommend them to
your teacher friends to help support our continuing work!

# Getting Started
This is an Arduino library that you can download as a zip file and install manually or you
can access it and install through the Arduino IDE Library manager (recommended
method). The Arduino Library manager updates hourly so you can easily access and
install the most current version through the IDE.

# Contributing
Email us at contact@databot.us.com if you are interested in contributing to the official
library, providing awesome sample sketches for databot™, or have suggestions. Thanks
for your support!

# License
This project is licensed under the GPL3 License - see the LICENSE.md file for details

# Acknowledgments
- The remarkable people at Arduino.cc who continue to innovate and drive the
most inspirational community of users on the planet.
- Sparkfun.com - a champion for the open source movement and a major resource
for guidance and open source code that helped make databot possible.
- Adafruit.com - a champion for electronics education and another major resource
that helped databot come to fruition.
- Dr. Sebastian Staacks and RWTH Aaachen University for the remarkable contribution of Phyphox to the global science education community.
- And Many others who contributed code to the Arduino ecosystem.
